/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package langid;

/**
 *
 * @author cle-32-pc
 */
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;

public class ProportionEstimator {
    
    public static void main(String[] args) throws IOException {
        
//        List str = new ArrayList();
//        str.add(1);str.add(1);str.add(1);str.add(1);str.add(0);str.add(0);str.add(1);str.add(0);str.add(1);str.add(0);
//        str.add(0);str.add(0);str.add(1);str.add(1);str.add(0);str.add(0);str.add(1);str.add(0);str.add(1);str.add(0);
//        
//        System.out.println(str);
//        System.out.println(smooth(str, 0));
//        
//        System.out.println(getProp(str));
//        System.out.println(getProp(smooth(str, 10)));
    }
    
    public static boolean hasUrdu(String[] content, HashMap sw) {
        /**
         * Iterates over the list of words in the input string array and checks
         * if each exists in the stopwords list, incrementing the Urdu word
         * count if it does. Returns true if any such word is found.
         */
        
        int total_words = content.length;
        int stop_words = 0;
        
        for (String word : content) {
            if (sw.containsKey(word)) {
                return true;
            }
        }
        return false;
    }
    
    public static float estimate_unigram(String[] content, HashMap lm) {
        /**
         * Iterates over the list of words in the input string array and checks
         * if each exists in the language model, incrementing the Urdu word
         * count if it does. Returns the fraction of Urdu by dividing the
         * estimated Urdu word count with the total size of the string array.
         */
        
        int total_words = content.length;
        int urdu_words = 0;
        
        for (String word : content) {
            if (lm.containsKey(word)) {
                urdu_words++;
            }
        }
        return urdu_words / (float) total_words;
    }
    
    public static float estimate_bigram(String[] content, HashMap lm) {
        /**
         * Iterates over the list of words in the input string array and checks
         * if each exists in the language model, incrementing the Urdu word
         * count if it does. Returns the fraction of Urdu by dividing the
         * estimated Urdu word count with the total size of the string array.
         */
        
        int total_bigrams = content.length - 1;
        int urdu_bigrams = 0;
        
        for (int i = 0; i < content.length - 1; i++) {
            String bigram = content[i] + " " + content[i + 1];
            if (lm.containsKey(bigram)) {
                urdu_bigrams++;
            }
        }
        return urdu_bigrams / (float) total_bigrams;
    }
    
    public static float estimate_context(String[] content, HashMap lm) {
        /**
         * Iterates over the list of words in the input string array and checks
         * if each independently exists in the language model, incrementing the Urdu word
         * count if it does. Returns the fraction of Urdu by dividing the
         * estimated Urdu word count with the total size of the string array.
         */
        
        int total_bigrams = content.length - 1;
        int urdu_bigrams = 0;
        
        for (int i = 0; i < content.length - 1; i++) {
            if (lm.containsKey(content[i]) && lm.containsKey(content[i + 1])) {
                urdu_bigrams++;
            }
        }
        return urdu_bigrams / (float) total_bigrams;
        
    }
    
    public static List predUrdu(String[] content, HashMap lm) {
        /**
         * Iterates over the list of words in the input string array and checks
         * if each independently exists in the language model, appending a boolean
         * value to a list if it does. Returns the list containing the boolean values.
         */
        
        List UrduFound = new ArrayList();
        
        for (int i = 0; i < content.length - 1; i++) {
            if (lm.containsKey(content[i]) && lm.containsKey(content[i + 1])) {
                UrduFound.add(1);
            } else {
                UrduFound.add(0);
            }
        }
        return UrduFound;
    }
    
    public static List smooth(List urduFound, Integer window) {
        /**
         * Iterates over the list of words in the input boolean list and checks
         * if the most frequent in the context is one or zero, creating a new list
         * with the result. Returns a list containing the smoothed result.
         */
        
        List smoothed = new ArrayList();
        
//        Integer window = 5;
        Integer begin = 0;
        Integer end = urduFound.size();
        
        for (int i = 0; i < urduFound.size(); i++) {
            if (i - window < 0) {
                begin = 0;
            } else {
                begin = i - window;
            }
            if (i + window+1 > urduFound.size()) {
                end = urduFound.size();
            } else {
                end = i + window+1;
            }
//            System.out.println("Begin:\t"+begin+"\tThis:\t"+i+"\tEnd:\t"+end);
            List context = urduFound.subList(begin, end);
//            System.out.println("Context:\t"+context.size());
            
            int ones = Collections.frequency(context, 1);
            int zeroes = Collections.frequency(context, 0);
            
            if (ones >= zeroes) {
                smoothed.add(1);
            } else {
                smoothed.add(0);
            }
        }
        return smoothed;
    }
    
    public static float getProp(List list) {
        return Collections.frequency(list, 1) / (float) list.size();
    }
    
}
