/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cle.org.pk.summarization.algorithms;

import cle.org.pk.utils.Preprocessor;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

/**
 *
 * @author cle-28-pc
 */
public class Algorithm1 {

    public Map<Integer, Double> sentenceScore = new HashMap<>();
    public Map<Integer, String> summarySentences = new HashMap<>();

    public static void main(String[] args) {

        /**
         * This string contains the text to be summarized.
         */
        String text = "طالبان کی حکومت کے پرخچے اڑ گئے۔ بے شمار افغان شہری اور طالبان جان سے گزر گئے لیکن انھوں نے اپنا مہمان امریکہ کے حوالے نہیں کیا۔ یہ محاربہ ابھی جاری ہے۔ اس معرکے میں آخری فتح کسے نصیب ہو گی؟ اس کا فیصلہ آج نہیں کل ہو گا جب تاریخ کا بے لچک منصف اپنا فیصلہ سنائے گا۔\n"
                + "طالبان اسلامی مبادیات و تعلیمات کی جو تشریح کرتے تھے، اس سے کوئی متفق ہو یا نہ ہو، اتنا سب جانتے ہیں کہ وہ نفاذ اسلام میں مخلص تھے۔ اسی سلسلے میں انھوں نے ہر بت توڑنے اور ہر نقشِ باطل مٹانے کا فیصلہ کیا اور بامیان کے علاقے میں گوتم بدھ کا سنگی مجسمہ ڈھانا شروع کر دیا۔ اس پر ساری دنیا چیخ اٹھی۔ اس چیخ پکار میں جاپان، سری لنکا اور بھارت کی صدا سب سے اونچی تھی، تو یہ بات معقول تھی یا نہیں، سمجھ میں آسانی سے آ گئی۔ لیکن گوتم بدھ کا مجسمہ ڈھانے یا نہ ڈھانے کے معاملے سے امریکہ کو کیوں دلچسپی تھی؟ یہ بڑی طرفہ تماشا بات ہے۔ ہمیں یاد ہے جب گوتم کا مجسمہ توڑا جا رہا تھا ان دنوں کسی امریکی دانشور کا ایک بیان اخبارات میں چھپا تھا جس میں طالبان سے کہا گیا تھا ''ﷲ کے بندو! تاریخ کے ورثے کی حفاظت کرو۔ افغانستان حضرت عمر فاروقؓ کے عہد میں فتح ہوا تھا۔ انھوں نے گوتم بدھ کو نہیں چھیڑا تو تم اس مجسمے سے چھیڑخانی کیوں کر رہے ہو؟\"\n"
                + "امریکہ کا یہ واویلا برطانوی صحافی رابرٹ فسک کی حال ہی میں شائع ہونے والی ایک الم‌انگیز رپورٹ پڑھ کر یاد آیا ہے۔ آج ہر شخص جانتا ہے کہ صدام کی مہلک ہتھیار بندیوں کے بارے میں امریکہ کے سارے دعوے سفید جھوٹ ثابت  ";


        /**
         * The method generateSummaries returns following three summaries.
         * 1-Three sentence summary.
         * 2-Five sentence summary.
         * 3-Summary with 30% compression ratio.
         */
        ArrayList<String> summ = new ArrayList<>();
        summ = new Algorithm1().generateSummaries(text);

        /**
         * The portion of code prints the generated summaries stored in summ ArrayList.
         * 
         */
        for (int i = 0; i < summ.size(); i++) {
            System.out.println("Summary No." + (i + 1));
            System.out.println(summ.get(i));
        }


    }

    public ArrayList<String> generateSummaries(String data) {

        String filename = "";
        Double compressionRate = 0.0;
        ArrayList<String> summaries = new ArrayList<>();
//        final File folder = new File(PATH);
        //for (final File fileEntry : folder.listFiles()) 

        {
            //if (fileEntry.isDirectory()) 
            {
            }
            //else 
            {
                try {
                    String docText = "";
                    ArrayList<String> docSentences = new ArrayList<>();
                    Preprocessor p = new Preprocessor();
                    Algorithm1 algo = new Algorithm1();
                    docText = data;
                    docSentences = p.extractSentences(docText);

                    String[] completeSentences = docText.split("۔");
                    p.LoadClosedClass();
                    docText = p.removeSpecialWords(docText);
                    docText = p.removeStopWords(docText);
                    String[] cleanedSentences = docText.split("۔");


                    for (int i = 0; i < cleanedSentences.length; i++) {
                        cleanedSentences[i] = p.normalize(cleanedSentences[i]);
                        cleanedSentences[i] = p.removeSpecialWords(cleanedSentences[i]);
                        cleanedSentences[i] = p.removeStopWords(cleanedSentences[i]);

                    }


                    p.generateVocabulary(cleanedSentences);
                    if (docSentences.size() >= 3) {
                        ;
                        algo.calculateSentenceScore(cleanedSentences, p.wordsCount.size());
                        algo.selectTopNSummarySentences(algo.sortByValues(algo.sentenceScore), docSentences, 3).split(",");
                        summaries.add(algo.printSentences(algo.sortByKeys(algo.summarySentences), "\\3\\" + filename));

                        if (docSentences.size() > 5) {
                            algo.summarySentences = new HashMap<>();
                            algo.selectTopNSummarySentences(algo.sortByValues(algo.sentenceScore), docSentences, 5);
                            summaries.add(algo.printSentences(algo.sortByKeys(algo.summarySentences), "\\5\\" + filename));
                        } else {
                            algo.summarySentences = new HashMap<>();
                            algo.selectTopNSummarySentences(algo.sortByValues(algo.sentenceScore), docSentences, 3);
                            summaries.add(docText);
                        }
                        algo.summarySentences = new HashMap<>();
                        compressionRate = Math.ceil(docSentences.size() * 0.3);
                        algo.selectTopNSummarySentences(algo.sortByValues(algo.sentenceScore), docSentences, Integer.valueOf(compressionRate.intValue())).split(",");
                        summaries.add(algo.printSentences(algo.sortByKeys(algo.summarySentences), "\\1_3\\" + filename));
                    } else {
                        summaries.add(docText);
                        summaries.add("");
                        summaries.add("");
                    }

                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }

        return summaries;
    }

    public String printSentences(Map<Integer, String> scores, String filename) {
        String content = "";
        for (Integer i : scores.keySet()) {

//            System.out.println(i);
//            System.out.println("Sentence"+);

            content += scores.get(i);
            content = content.trim();
//            content += "\n";
        }

//        System.out.println("Summary is:");
//        System.out.println(content);

        return content;
//        try {
////            System.out.println("Writing Filename" + filename);
//            File file = new File(filename);
//            // if file doesnt exists, then create it
//            if (!file.exists()) {
//                file.createNewFile();
//            }
//            FileWriter fw = new FileWriter(file.getAbsoluteFile());
//            BufferedWriter bw = new BufferedWriter(fw);
//            bw.write(content);
//            bw.close();
////            System.out.println("Done");
//        } catch (IOException e) {
//            e.printStackTrace();
//        }
    }

    public String selectTopNSummarySentences(Map<Integer, Double> scores, ArrayList<String> sentences, int n) {
        String numbers = "";
        ArrayList<Integer> indices = new ArrayList<>();

        for (Integer i : scores.keySet()) {
//            System.out.println("Indices"+i);
            indices.add(i);
        }
        for (int i = 0; i < n; i++) {
//            System.out.println("Selecting:" + indices.get(i));
            //numbers += indices.get(i) + ",";
//            System.out.println("Sentence="+sentences.get(indices.get(i)));
            summarySentences.put(indices.get(i), sentences.get(indices.get(i)));
        }

        return numbers;

    }

    public static <K extends Comparable, V extends Comparable> Map<K, V> sortByValues(Map<K, V> map) {
        List<Map.Entry<K, V>> entries = new LinkedList<Map.Entry<K, V>>(map.entrySet());

        Collections.sort(entries, new Comparator<Map.Entry<K, V>>() {
            @Override
            public int compare(Map.Entry<K, V> o1, Map.Entry<K, V> o2) {
                return o2.getValue().compareTo(o1.getValue());
            }
        });

        //LinkedHashMap will keep the keys in the order they are inserted
        //which is currently sorted on natural ordering
        Map<K, V> sortedMap = new LinkedHashMap<K, V>();
        for (Map.Entry<K, V> entry : entries) {
            sortedMap.put(entry.getKey(), entry.getValue());
        }

        return sortedMap;
    }

    public static <K extends Comparable, V extends Comparable> Map<K, V> sortByKeys(Map<K, V> map) {
        List<K> keys = new LinkedList<K>(map.keySet());
        Collections.sort(keys);

        //LinkedHashMap will keep the keys in the order they are inserted
        //which is currently sorted on natural ordering
        Map<K, V> sortedMap = new LinkedHashMap<K, V>();
        for (K key : keys) {
            sortedMap.put(key, map.get(key));
        }

        return sortedMap;
    }

    public void printScores() {
        System.out.println("Scores of the sentences");
        for (Integer key : sentenceScore.keySet()) {
            System.out.println(sentenceScore.get(key));
        }
    }

    public void calculateSentenceScore(String[] Sentences, int totalWords) {

        for (int i = 0; i < Sentences.length - 1; i++) {
//            System.out.println("Sentence:" + Sentences[i]);
//            System.out.println("Content words in sentence" + i + " =" + Sentences[i].split(" ").length);
//            System.out.println("Total Words in doc:" + totalWords);
            double score = (double) ((double) (Sentences[i].split(" ").length - 1) / (double) totalWords) * 100.0;
            if (i == 0) {
                //   sentenceScore.put(i, 10000.0);
                sentenceScore.put(i, score);

            } else {
                sentenceScore.put(i, score);
            }
        }

    }
}
