/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cle.org.pk.utils;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.text.DecimalFormat;
import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

/**
 *
 * @author cle-28-pc
 */
public class Preprocessor {

    
    public Map<String, Double> wordFirstIndex = new HashMap<>();
    public Map<String, Double> wordLifeSpan = new HashMap<>();
    public Map<String, Double> wordLastIndex = new HashMap<>();
    public Map<String, Integer> summarySentences = new HashMap<>();
    public Map<String, Integer> sentencesParagraphsLocation = new HashMap<>();
    public Map<String, Integer> sentencesParagraphsNo = new HashMap<>();
    public Map<Integer, Integer> paragraphsSentenceCounts = new HashMap<>();
    public Map<String, Integer> wordsDF = new HashMap<>();
    public Map<Integer, Double> sentencesTFISF = new HashMap<>();
    public Map<Integer, Double> sentencesZScores = new HashMap<>();
    public Map<String, Integer> ClosedClass = new HashMap<>();
    public Map<String, Integer> wordsCount = new HashMap<>();
    public Map<String, Double> wordsZmeasure = new HashMap<>();
    public static String[] punc = {"\\؟", "\\'", "،", "~", "؂", "…", "'", "\\.", "\\?", "،", "؟", "'", "؛", "\"", "\\(", "\\)", "‘", "’", ",", "؍", "!", "ْ", "ٔ", "ٰ", "َ", "ِ", "ُ", "ٖ", "ً", "ّ", "ٗ", "ؔ", "ؓ", "ؑ", "ؐ", "ؒ"};
    public Map<Integer, ArrayList<String>> document = new HashMap<>();
    HashMap<String, Integer> wordsFrequencies = new HashMap<>();
    public ArrayList<HashMap<String, Integer>> tf = new ArrayList<>();
    Map<String, Double> TFIDF = new HashMap<>();
    public ArrayList<Map<String, Double>> completeDocTFIDF = new ArrayList<>();

    public String normalize(String str) {

        str = str.replaceAll("\\p{M}+", "");        // remove all diacritics
        str = str.replaceAll("[^\\p{L}+]", " ");    // replace all non-letter characters with a space
//        str = str.replaceAll("[^\\p{InArabic}+]", " ");     // replace all non-Arabic characters with a space
        return str.trim();
    }

    public void releaseMemory() {
        summarySentences = new HashMap<>();
        sentencesParagraphsLocation = new HashMap<>();
        sentencesParagraphsNo = new HashMap<>();
        paragraphsSentenceCounts = new HashMap<>();
        sentencesTFISF = new HashMap<>();
        document = new HashMap<>();
        wordsFrequencies = new HashMap<>();
        tf = new ArrayList<>();
        TFIDF = new HashMap<>();
        completeDocTFIDF = new ArrayList<>();
        wordsCount = new HashMap<>();

    }


    public void LoadClosedClass() {
        try {
            InputStream in = Preprocessor.class.getResourceAsStream("/stopwords.txt");
            InputStreamReader stream = new InputStreamReader(in, "UTF-8");
            String line;
            final BufferedReader buffer = new BufferedReader(stream);

            while ((line = buffer.readLine()) != null) {
                String[] temp = line.split(":");
                for (int i = 0; i < temp.length; i++) {
                    if (!temp[i].isEmpty()) {
//                        System.out.println(temp[i].trim());
                        ClosedClass.put(temp[i].trim(), 1);
                    }
                }
            }


        } catch (Exception ex) {
            ex.printStackTrace();
        }

    }

    public String removeStopWords(String text) {
        String[] tokens = text.split("\\s+");
        String sentence = "";

        for (int i = 0; i < tokens.length; i++) {


            if (ClosedClass.containsKey(tokens[i].trim())) {
            } else {
                sentence += tokens[i] + " ";
            }
        }
        return sentence;
    }

    public ArrayList<String> extractSentences(String text) {
        int para = 0;
        int paraSentencesCount = 0;
        int sentenceParaLoc = 1;
        ArrayList<String> tempSen = new ArrayList<>();
        String append = "";
        String temp = "";
        boolean start = false;
        boolean end = false;
        for (int i = 0; i < text.length(); i++) {
            if (text.charAt(i) != '~') {
                end = false;
                if (text.charAt(i) == '۔') {
                    append += text.charAt(i);
//                   append+="  ";
                } else {
                    append += text.charAt(i);
                }
            }
            if (text.charAt(i) == '۔') {
                paraSentencesCount++;
                sentencesParagraphsLocation.put(append, (paraSentencesCount));
                sentencesParagraphsNo.put(append, para + 1);
//                sentenceParaLoc++;
                tempSen.add(append);
                append = "";
                end = true;
            }
            if (text.charAt(i) == '~') {
                if (end) {
                    end = false;
//                    sentenceParaLoc = 0;
//                    System.out.println("Paragraph Length=" + paraSentencesCount);
                    paragraphsSentenceCounts.put(para + 1, paraSentencesCount);
//                    tempSen.add("Paragraph No:" + para++);
                    para++;
                    paraSentencesCount = 0;
                }
            }
//                System.out.println(text.charAt(i));
        }

        return tempSen;
    }
    public String removeSpecialWords(String text) {
        for (int i = 0; i < punc.length; i++) {
            //System.out.println("Stop Word:"+ClosedClass.get(i));
            String stopWord = punc[i];
            if (text.contains(stopWord)) {
//                System.out.println("Found"+stopWord);
//                text = text.replaceAll(stopWord, " " + stopWord + " ");
                text = text.replaceAll(stopWord, "");
            }
        }
        return text;
    }

    public Map<String, Integer> generateVocabularyForSentences(String Sentences) {

        wordsCount = new HashMap<>();
        Sentences = Sentences.replaceAll("\\s+", " ");
        String[] words = Sentences.split(" ");

        for (int j = 0; j < words.length; j++) {

            if (words[j].trim().length() > 1) {
//                    System.out.println("Adding " + words[j] + "=Length" + words[j].length());
                words[j] = words[j].replaceAll("[-+.^:,]", "");
                if (!(wordsCount.containsKey(words[j].trim()))) {
                    wordsCount.put(words[j].trim(), 1);
                } else {
                    int count = wordsCount.get(words[j].trim());
                    wordsCount.remove(words[j].trim());
                    wordsCount.put(words[j].trim(), count + 1);
                }

            }


        }
        return wordsCount;
    }

    public void computeZmeasures(String[] sentence, double mean, double std) {

        double sum = 0.0;
        for (String keys : wordsCount.keySet()) {
            double val = (wordsCount.get(keys) - mean) / std;
            wordsZmeasure.put(keys, std);
        }

        for (int i = 0; i < sentence.length; i++) {

            sum = 0.0;
            String[] tokens = sentence[i].split("\\s+");

            for (int j = 0; j < tokens.length; j++) {
                sum += wordsZmeasure.get(tokens[j].trim());
            }
            sentencesZScores.put(i, sum);
        }

    }

    public Map<String, Integer> generateVocabulary(String[] Sentences) {
        for (int i = 0; i < Sentences.length; i++) {
//            System.out.println("Sentence:"+Sentences[i]);
            Sentences[i] = Sentences[i].replaceAll("\\s+", " ");
            String[] words = Sentences[i].split(" ");

            for (int j = 0; j < words.length; j++) {

                if (words[j].trim().length() > 0) 

                {
//                    System.out.println("Adding " + words[j] + "=Length" + words[j].length());
                    words[j] = words[j].replaceAll("[-+.^:,]", "");
                    if (!(wordsCount.containsKey(words[j].trim()))) {
                        wordsCount.put(words[j].trim(), 1);
                    } else {
                        int count = wordsCount.get(words[j].trim());
                        wordsCount.remove(words[j].trim());
                        wordsCount.put(words[j].trim(), count + 1);
                    }

                }

            }

        }
        return wordsCount;
    }

   

    public void calculateTermFrequencies(String[] sentences) {
        for (int i = 0; i < sentences.length; i++) {
            wordsFrequencies = new HashMap<>();
            for (String keys : wordsCount.keySet()) {
                if (keys.length() > 0) {
//                    if (keys.equals("ایک") && i==0) 
                    {
                        wordsFrequencies.put(keys, calculateOccurences(keys, sentences[i]));
                    }
                }
            }
            tf.add(wordsFrequencies);
        }
    }

    int calculateOccurences(String word, String doc) {
        int count = 0;
        String[] tokens = doc.split(" ");
        for (int i = 0; i < tokens.length; i++) {

            tokens[i] = tokens[i].replaceAll("[-+.^:,]", "");
            if (tokens[i].equals(word)) {
                count++;
            }
        }
        return count;
    }

    public void calculateTermDocumentFrequencies() {
//        wordsDF = new HashMap<>();
        for (int i = 0; i < tf.size(); i++) {
//            System.out.println("Comparing for Doc " + i);
            for (String keys : wordsCount.keySet()) {
//                if(keys.equals("ایک"))
                {
//                System.out.println("Finding df for keys " + keys + "Wtih length" + keys.length());
                    if (keys.length() > 0) {

                        if (tf.get(i).get(keys.trim()) != 0) {
//                            System.out.println("Found");
                            if (!(wordsDF.containsKey(keys))) {
                                wordsDF.put(keys, 1);
                            } else {
                                int size = wordsDF.get(keys);
                                wordsDF.remove(keys);
                                wordsDF.put(keys, size + 1);
                            }
                        }
                    }
                }
            }
        }
    }

    public void keywordDepths(String text) {


        String[] docTokens = text.split("\\s+");
        ArrayList<Double> indices = new ArrayList<>();
//        System.out.println("Total words:" + docTokens.length);
        for (String keys : wordsCount.keySet()) {
            indices = new ArrayList<>();
            for (int i = 0; i < docTokens.length; i++) {
                if (docTokens[i].trim().equals(keys)) {
//                    System.out.println("Word: " + keys + " Found at:" + (i + 1));
                    indices.add(i + 1.0);
                }
            }
            double firstInd = 1 - ((double) indices.get(0) / docTokens.length);
            double lastInd = (double) indices.get(indices.size() - 1) / docTokens.length;
            double span = (double) (indices.get(indices.size() - 1) - indices.get(0)) / docTokens.length;

            //   if (firstInd < 0.9) {
//                firstInd = 0.0;
//            }
//            if (lastInd < 0.9) {
//                lastInd = 0.0;
//            }


            wordFirstIndex.put(keys.trim(), firstInd);
            wordLastIndex.put(keys.trim(), lastInd);
            wordLifeSpan.put(keys.trim(), span);


        }

        for (String keys : wordFirstIndex.keySet()) {
//            System.out.println("Word:" + keys + " First Index:" + wordFirstIndex.get(keys) + " Last Index:" + wordLastIndex.get(keys) + " Span:" + wordLifeSpan.get(keys));
        }

    }

    public double[][] calculateTFIDF(String[] Sentences) {
        int A_row;
        int count;
        int A_col;
        double sum = 0.0;
        double[][] A_A = new double[0][0];
        for (int i = 0; i < tf.size(); i++) {
            TFIDF = new HashMap<>();
            for (String keys : wordsCount.keySet()) {
//                System.out.println("Term:" + keys);
                Double idf;
                Double t_f;
                t_f = (double) (tf.get(i).get(keys).intValue());
                idf = Math.log10((double) ((double) (Sentences.length)) / ((double) wordsDF.get(keys).intValue()));
                double tfidf = t_f * idf;
                DecimalFormat f = new DecimalFormat("##.00");
                tfidf = Double.parseDouble(f.format(tfidf));
                TFIDF.put(keys, tfidf);
//                System.out.println("Term:" + keys);
//                System.out.println("Term Frequency:" + t_f);
//                System.out.println("IDF value:"+idf);
//                System.out.println("Document Frequency:" + wordsDF.get(keys).intValue());
//                System.out.println("Total Documents:" + (Sentences.length - 1));
//                System.out.println("TF-ISF Value=" + t_f * idf);
            }
            completeDocTFIDF.add(TFIDF);
        }
        A_row = wordsDF.size();
        count = 0;
        A_col = completeDocTFIDF.size();
        A_A = new double[A_row][A_col];
        for (int i = 0; i < A_col; i++) {
            count = 0;
            for (String keys : completeDocTFIDF.get(0).keySet()) {
                A_A[count][i] = completeDocTFIDF.get(i).get(keys);
//                System.out.print(A_A[count][i]+"\t");
                count++;
            }
//            System.out.println("");
        }
        for (int i = 0; i < A_col; i++) {
            sum = 0.0;
            for (int j = 0; j < A_row; j++) {
                sum += A_A[j][i];

            }
            sentencesTFISF.put(i, sum);
        }
//        System.out.println("Printing Scores in function.");
//        for (int k = 0; k < sentencesTFISF.size(); k++) {
//            System.out.println(sentencesTFISF.get(k));
//        }
        return A_A;
    }

    public double[][] calculateMeanTFISF(String[] Sentences, double limit) {
        int A_row;
        int count;
        int A_col;
        double sum = 0.0;
        double[][] A_A = new double[0][0];
        for (int i = 0; i < tf.size() - 1; i++) {
            TFIDF = new HashMap<>();
            for (String keys : wordsCount.keySet()) {
//                System.out.println("Term:" + keys);
                Double idf;
                Double t_f;
                t_f = (double) (tf.get(i).get(keys).intValue());
                idf = Math.log10((double) ((double) (Sentences.length - 1)) / ((double) wordsDF.get(keys).intValue()));
                double tfidf = t_f * idf;
                DecimalFormat f = new DecimalFormat("##.00");
                tfidf = Double.parseDouble(f.format(tfidf));
                TFIDF.put(keys, tfidf);
//                System.out.println("Term:" + keys);
//                System.out.println("Term Frequency:" + t_f);
//                System.out.println("IDF value:"+idf);
//                System.out.println("Document Frequency:" + wordsDF.get(keys).intValue());
//                System.out.println("Total Documents:" + (Sentences.length - 1));
//                System.out.println("TF-ISF Value=" + t_f * idf);
            }
            completeDocTFIDF.add(TFIDF);
        }


        A_row = wordsDF.size();
        count = 0;
        A_col = completeDocTFIDF.size();
        A_A = new double[A_row][A_col];
        for (int i = 0; i < A_col; i++) {
            count = 0;
            Map<String, Double> topWords = new HashMap<>();
            Map<String, Double> topWords2 = new HashMap<>();
            topWords = sortByValues(completeDocTFIDF.get(i));

            int wordCount = 0;
            for (String keys : topWords.keySet()) {

//                System.out.println("Limit is:"+limit);

                if (wordCount >= limit) {
                    break;
                } else {
                    topWords2.put(keys, 1.0);
                }
                wordCount++;
            }


            double val = computeTFIDFAverage(completeDocTFIDF.get(i), Sentences[i].split("\\s+").length);

//            System.out.println("Sentence No:"+i);
//            System.out.println("TF-ISF Mean:"+val);


            //for cleaning below average
//            for (String keys : topWords.keySet()) {
//
//                if (completeDocTFIDF.get(i).get(keys) >= val) {
//
//                    A_A[count][i] = completeDocTFIDF.get(i).get(keys);
//                } else {
//                    A_A[count][i] = 0.0;
//                }
//                count++;
//
//            }

            for (String keys : topWords2.keySet()) {

                if (completeDocTFIDF.get(i).get(keys) >= val) {
                    A_A[count][i] = completeDocTFIDF.get(i).get(keys);
                } else {
                    A_A[count][i] = 0.0;
                }
                count++;
            }








//            System.out.println("");
        }
        for (int i = 0; i < A_col; i++) {
            sum = 0.0;
            for (int j = 0; j < A_row; j++) {
                sum += A_A[j][i];

            }
//            System.out.println("Computing TF-ISF for sentence:"+Sentences[i]);

            sentencesTFISF.put(i, sum);

        }
//        System.out.println("Printing Scores in function.");
//        for (int k = 0; k < sentencesTFISF.size(); k++) {
//            System.out.println(sentencesTFISF.get(k));
//        }
        return A_A;
    }

    public <K extends Comparable, V extends Comparable> Map<K, V> sortByValues(Map<K, V> map) {
        List<Map.Entry<K, V>> entries = new LinkedList<Map.Entry<K, V>>(map.entrySet());

        Collections.sort(entries, new Comparator<Map.Entry<K, V>>() {
            @Override
            public int compare(Map.Entry<K, V> o1, Map.Entry<K, V> o2) {
                return o2.getValue().compareTo(o1.getValue());
            }
        });

        //LinkedHashMap will keep the keys in the order they are inserted
        //which is currently sorted on natural ordering
        Map<K, V> sortedMap = new LinkedHashMap<K, V>();
        for (Map.Entry<K, V> entry : entries) {
            sortedMap.put(entry.getKey(), entry.getValue());
        }

        return sortedMap;
    }

    public double computeTFIDFAverage(Map<String, Double> values, int length) {

        double avg = 0.0;

        for (String keys : values.keySet()) {

//            System.out.println("Key:"+keys+","+" Value:"+values.get(keys));

            avg += values.get(keys);
        }

        return avg / values.size();
    }
}
